{DSBROWSE - June 26, 1996 - This Program is written in Delphi 1.0.  It is a 16-bit program
that uses Novell's API's written for Delphi.  This program lists all objects in the current
context, changes to other contexts.  It will list all attributes for a given object and all
values for a given attribute.  The coding is similar to C but uses some generic pointers for
the Buf_T typedef.  The generic pointers seem to avoid GPFs.}

unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, calmis16, locwin16, netnds16, netcon16, Buttons, Menus,
  ExtCtrls;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Options1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    SetContext1: TMenuItem;
    Help2: TMenuItem;
    Panel1: TPanel;
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    ComboBox2: TComboBox;
    Bevel1: TBevel;
    Label3: TLabel;
    N1: TMenuItem;
    Refresh1: TMenuItem;
    ListBox2: TListBox;
    Label4: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure Refresh1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    procedure GetAttributes;
    procedure GetValues;
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  userbmp, oubmp, pqueuebmp, serverbmp, volumebmp, orolebmp, pserverbmp,
  groupbmp, bobjbmp, printerbmp, appbmp : TBitmap;
  dContext:NWDSContextHandle;
  attrName, GObjectName:array [0..255] of char;

implementation

{$R *.DFM}

procedure TMainForm.Exit1Click(Sender: TObject);
begin
	Close;
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
var
  ccode:NWDSCCODE;
  tptr:pointer;
  newcontext:array [0..255] of char;
begin
  strpcopy(newcontext,ComboBox2.text);
  tptr:=@newcontext;
	ccode:=NWDSSetContext(dContext,DCK_NAME_CONTEXT,tptr);
  refresh1Click(BitBtn1);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  ccode:NWDSCCODE;
  lpNULL:nptr;
  locale:pnstr;
  lconvInfo:LCONV;
begin
   if fileexists('user.bmp')then
   begin
      userbmp:=Tbitmap.Create;
      oubmp:=Tbitmap.Create;
      pqueuebmp:=Tbitmap.Create;
      serverbmp:=Tbitmap.Create;
		 volumebmp:=Tbitmap.Create;
		 orolebmp:=Tbitmap.Create;
      pserverbmp:=Tbitmap.Create;
  	 groupbmp:=Tbitmap.Create;
  	 bobjbmp:=Tbitmap.Create;
  	 printerbmp:=Tbitmap.Create;
      appbmp:=Tbitmap.Create;
      userbmp.LoadFromFile('user.bmp');
      oubmp.LoadFromFile('ou.bmp');
      pqueuebmp.LoadFromFile('pqueue.bmp');
      serverbmp.LoadFromFile('server.bmp');
      volumebmp.LoadFromFile('volume.bmp');
      orolebmp.LoadFromFile('orole.bmp');
      pserverbmp.LoadFromFile('pserver.bmp');
      groupbmp.LoadFromFile('group.bmp');
      bobjbmp.LoadFromFile('bobj.bmp');
      printerbmp.LoadFromFile('printer.bmp');
      appbmp.LoadFromFile('app.bmp');
   end
   else
   	ShowMessage('Could not load bitmaps!');

	{Initialize the APIs}
  ccode:=NWCallsINIT(lpNULL,lpNULL);
  if (ccode<0)then
  begin
  	ShowMessage('NWCallsInit Failed'+#13+'Error Code: '+inttostr(ccode));
     Screen.Cursor := crDefault;
     exit;
  end;

  {Initialize Locale, this is not necessay with post SDK7 nwcallsinit}
	NWLsetlocale(LC_ALL, @locale);

  {Get Locale Information and store in lconvInfo, not necessay with post SDK7}
  NWLlocaleconv(@lconvInfo);

  {Initialize the unicodetables, not necessay with post SDK7         }
  ccode:=NWInitUnicodeTables(LconvInfo.country_id, lconvInfo.code_page);
  if (ccode<0)then
  begin
  	ShowMessage('NWInitUnicodeTables Failed'+#13+'Error Code: '+inttostr(ccode));
     NWFreeUnicodeTables;
     Screen.Cursor := crDefault;
     exit;
  end;
  {Creates a Directory context for Directory client operations and initializes it
  to the default configuration}
  dContext:=NWDSCreateContext;
  if dContext = ERR_CONTEXT_CREATION then
  begin
     ShowMessage('NWDSCreateContext Failed');
     NWDSFreeContext(dContext);
     Screen.Cursor := crDefault;
     exit;
  end;
  Refresh1Click(MainForm);
  end;



procedure TMainForm.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
 Bitmap: TBitmap;
 Offset: Integer;
begin
  Offset:=0;
  with (Control as TListBox).Canvas do
  begin
   FillRect(Rect);
   Bitmap:=TBitmap(ListBox1.Items.Objects[Index]);
   if Bitmap <> nil then
   begin
    BrushCopy(Bounds(Rect.Left + 2, Rect.Top + 2, Bitmap.Width,Bitmap.Height),
      Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height), clRed);
    Offset:=Bitmap.Width+8;
   end;
   TextOut(Rect.Left + Offset, Rect.Top, ListBox1.Items[Index]);
  end;
end;

procedure TMainForm.Refresh1Click(Sender: TObject);
var
  outBuf:^Buf_T;
  ccode:NWDSCCODE;
  nContext:array [0..MAX_DN_CHARS] of nstr;
  ppoutBuf:pointer;
  iterator:NWDS_ITERATION;
  typelessName: array [0..255] of char;
  objectCount:NWCOUNT;
  flags: nuint32;
  i:Integer;
  attrCount:nint32;
  ObjectInfo:Object_Info_T;
  GObjectNAme: array[0..255] of char;
  treename: array[0..100] of char;
begin
 ListBox1.Items.Clear;
 Screen.Cursor := crHourGlass;
  {Get the current context and display it in ComboBox2}

  ccode:=NWDSGetContext(dContext,DCK_NAME_CONTEXT,@nContext);
  if (ccode<0)then
  begin
     Screen.Cursor := crDefault;
  	ShowMessage('NWDSGetContext Failed'+#13+'Error Code: '+inttostr(ccode));
     NWDSFreeContext(dContext);
     exit;
  end;

  ComboBox2.Text:=strpas(nContext);

  ccode:=NWDSRemoveAllTypes(dContext,@nContext,@typelessName);
  if (ccode<0)then
  begin
     Screen.Cursor := crDefault;
  	ShowMessage('NWDSRemoveAllTypes Failed'+#13+'Error Code: '+inttostr(ccode));
     exit;
  end;

	ccode:=NWDSGetContext(dContext,DCK_FLAGS,@flags);
  if (ccode<0)then
  begin
     Screen.Cursor := crDefault;
  	ShowMessage('NWDSGetContext Flags Failed'+#13+'Error Code: '+inttostr(ccode));
     exit;
  end;

  flags:=flags OR DCV_TYPELESS_NAMES;
  flags:=flags AND (NOT(DCV_CANONICALIZE_NAMES));

  ccode:=NWDSSetContext(dContext,DCK_FLAGS,@flags);
  if (ccode<0)then
  begin
     Screen.Cursor := crDefault;
  	ShowMessage('NWDSSetContext Flags Failed'+#13+'Error Code: '+inttostr(ccode));
     exit;
  end;

  {Allocates a Buf_T for a result buffer to a Directory Services function}
  ccode:=NWDSAllocBuf(DEFAULT_MESSAGE_LEN, @outBuf);
  if (ccode<0)then
  begin
     Screen.Cursor := crDefault;
  	ShowMessage('NWDSAllocBuf Failed'+#13+'Error Code: '+inttostr(ccode));
     NWDSFreeContext(dContext);
     exit;
  end;

  {Use dummy pointers to avoid GPFs in Delphi}
  ppoutbuf := outbuf;

  {Add DS Objects in context to ListBox1}
  iterator:=-1;

  repeat
  ccode:=NWDSList(dContext,@nContext,@iterator,ppoutbuf);
  if (ccode=-601)then
  begin
     Screen.Cursor := crDefault;
     ShowMessage('Could not locate object in the tree');
     exit;
  end;
  if (ccode<0) then
  begin
     Screen.Cursor := crDefault;
  	ShowMessage('NWDSList Failed'+#13+'Error Code: '+inttostr(ccode));
     exit;
  end;

  {Determine the number of subordinate objects contained in the result buffer}
  ccode:=NWDSGetObjectCount(dContext, ppoutbuf, @objectCount);
  if (ccode <> 0)then
  begin
  	ShowMessage('NWDSGetObjectCount Failed'+#13+'Error Code: '+inttostr(ccode));
     Screen.Cursor := crDefault;
     exit;
	end;

  for i := 1 to objectCount do
  begin
     ccode := NWDSGetObjectName(dContext,ppoutbuf,@gobjectName,@attrCount,@objectInfo);
     if (ccode <> 0)then
     begin
        ShowMessage('NWDSGetObjectName Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        exit;
     end;

     if pos('User',ObjectInfo.baseClass)>0 then
     	ListBox1.Items.AddObject(strpas(gobjectName), userbmp)
     else if pos('Queue',ObjectInfo.baseClass)>0then
     	ListBox1.Items.AddObject(strpas(gobjectName), pqueuebmp)
     else if pos('Organizational Unit',ObjectInfo.baseClass)>0then
     	ListBox1.Items.AddObject(strpas(gobjectName), oubmp)
     else if pos('NCP Server',ObjectInfo.baseClass)>0then
     	ListBox1.Items.AddObject(strpas(gobjectName), serverbmp)
     else if pos('Volume',ObjectInfo.baseClass)>0then
     	ListBox1.Items.AddObject(strpas(gobjectName), volumebmp)
     else if pos('Organizational Role',ObjectInfo.baseClass)>0then
     	ListBox1.Items.AddObject(strpas(gobjectName), orolebmp)
     else if pos('Print Server',ObjectInfo.baseClass)>0then
 		  	ListBox1.Items.AddObject(strpas(gobjectName), pserverbmp)
     else if pos('Group',ObjectInfo.baseClass)>0then
     	ListBox1.Items.AddObject(strpas(gobjectName), groupbmp)
     else if pos('Bindery Object',ObjectInfo.baseClass)>0then
     	ListBox1.Items.AddObject(strpas(gobjectName), bobjbmp)
     else if pos('Printer',ObjectInfo.baseClass)>0then
     	ListBox1.Items.AddObject(strpas(gobjectName), printerbmp)
     else if pos('Application',ObjectInfo.baseClass)>0then
     	ListBox1.Items.AddObject(strpas(gobjectName), appbmp)
     else
        ListBox1.Items.Add(strpas(gobjectName));
  end;
  until iterator=-1;
  if (strpas(nContext)<>'[Root]') then
   ListBox1.Items.insert(0,'..');
  Screen.Cursor := crDefault;  {Show Default cursor}
  Label3.Caption:='Found '+inttostr(ListBox1.Items.Count-1)+' objects';
  NWDSFreeBuf(ppoutbuf);
end;

procedure TMainForm.ListBox2Click(Sender: TObject);
begin
   strpcopy(@gobjectName,listbox1.items[listbox1.itemindex]+'.'+ComboBox2.Text);
   strpcopy(attrName,listbox2.items[listbox2.Itemindex]);
   Memo1.Lines.clear;
   GetValues;
end;

procedure TMainForm.GetValues;
var
  outBuf2,inbuf2:^Buf_T;
  iterator:NWDS_ITERATION;
  attr:array [0..MAX_DN_CHARS+1] of char;
  attrval2:array [0..MAX_DN_CHARS+1] of char;
  attrval, attrptr, outptr,inptr, onptr :pointer;
  i,j:Integer;
  Var fileHandle, fileHandle2 : NWFILE_HANDLE;
  hattrValue:NWHANDLE;
  ccode:NWDSCCODE;
  attrcount,valcount:NWCOUNT;
  syntax:NWSYNTAX_ID;
  infoType : nuint32;
  counter: Integer;
	attrSize:NWSIZE;
  privs:NWDS_PRIVILEGES;
  sattrName, rights, trim:string;
  days: real;
  seconds: nuint32;
  trim2: array [0..100] of char;
  tmpBuffer:array [0..256] of char;
 begin

  ccode:=NWDSAllocBuf(DEFAULT_MESSAGE_LEN, @inbuf2);
  if (ccode <> 0)then
  begin
        ShowMessage('NWDSAllocBuf Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        exit;
  end;

  ccode:=NWDSAllocBuf(DEFAULT_MESSAGE_LEN, @outBuf2);
  if (ccode <> 0)then
  begin
        ShowMessage('NWDSAllocBuf Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        NWDSFreeBuf(@inBuf2);
        exit;
  end;


  {Use generic pointers to avoid GPFs}
  inptr:=inBuf2;
  outptr:=outBuf2;

  ccode:=NWDSInitBuf(dContext,DSV_READ,inptr);
  if (ccode <> 0)then
  begin
        ShowMessage('NWDSInitBuf Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        NWDSFreeBuf(inptr);
        NWDSFreeBuf(outptr);
        exit;
  end;

  ccode:=NWDSPutAttrName(dContext,inptr,@attrName);
  if (ccode <> 0)then
  begin
    ShowMessage('NWDSPutAttrName Failed'+#13+'Error Code: '+inttostr(ccode));
    Screen.Cursor := crDefault;
    NWDSFreeBuf(inptr);
    NWDSFreeBuf(outptr);
    exit;
  end;

iterator:=-1;

  ccode:=NWDSRead(dContext,@gobjectName,1,FALSE,inptr,@iterator,outptr);
  if (ccode <> 0) then
  begin
  		if (ccode = -603) then
        begin
        	ShowMessage('-603: The Requested attribute could not be found!');
        end
        else if (ccode = -601) then
        	ShowMessage('-601: The Requested object could not be read!')
        else
          ShowMessage('NWDSRead Failed'+#13+'Error Code: '+inttostr(ccode));
        NWDSFreeBuf(inptr);
        NWDSFreeBuf(outptr);
        Screen.Cursor := crDefault;
        exit;
  end;
  ccode:=NWDSGetAttrCount(dContext,outptr,@attrCount);
  if (ccode <> 0)then
  begin
        ShowMessage('NWDSGetAttrCount Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        exit;
  end;
  for i:=1 to attrcount do
  begin
     ccode:=NWDSGetAttrName(dContext,outptr,@attrName,@valCount,@syntax);
       if (ccode <> 0)then
       begin
         ShowMessage('NWDSGetAttrName Failed'+#13+'Error Code: '+inttostr(ccode));
         Screen.Cursor := crDefault;
         exit;
       end;

     for j:=1 to valcount do
     begin

   { Allocate contiguous memory --
    Note that the attribute value size is computed each time a value
	  is read.  Each attribute may have multiple values and each value
	  may be a different size. }

        ccode := NWDSComputeAttrValSize(dContext, outptr, syntax, @attrSize);
        if (ccode < 0)then
        begin
          ShowMessage('NWDSComputeAttrValSize Failed'+#13+'Error Code: '+inttostr(ccode));
          NWDSFreeBuf(inptr);
          NWDSFreeBuf(outptr);
          Screen.Cursor := crDefault;
          exit;
        end;

        {ShowMessage(inttostr(attrSize));}
        hattrValue := LocalAlloc(LHND, NUINT(attrSize));
        if hattrValue=0 then
        begin
          ShowMessage('LocalAlloc Failed'+#13+'Error Code: 0');
          NWDSFreeBuf(inptr);
          NWDSFreeBuf(outptr);
          Screen.Cursor := crDefault;
          exit;
        end;

        attrptr := LocalLock(hattrValue);

        ccode:=NWDSGetAttrVal(dContext,outptr,syntax,@attrval);
        if (ccode <> 0)then
        begin
          ShowMessage('NWDSGetAttrVal Failed'+#13+'Error Code: '+inttostr(ccode));
          NWDSFreeBuf(inptr);
          NWDSFreeBuf(outptr);
          Screen.Cursor := crDefault;
          exit;
        end;

        attrptr:=@attrval;
        if syntax=23 then {SYN_BACK_LINK}
        begin
          memo1.Lines.Add(inttostr(Back_Link_t(attrptr^).remoteID));
          trim:=strpas(@Back_Link_T(attrptr^).objectName);
          delete(trim,1,4);
          memo1.Lines.Add(trim);
        end
        else if syntax=7  then {SYN_BOOLEAN}
        begin
          if Boolean_t(attrVal)=1 then
            memo1.Lines.Add('TRUE')
          else
            memo1.Lines.Add('FALSE');
        end
        else if syntax=2  then {SYN_CE_STRING}
        begin
          memo1.Lines.Add(strpas(@CE_string_T(attrVal)));
        end
        else if syntax=6  then {SYN_CI_LIST}
        begin
          trim:=strpas(@CI_List_T(attrptr^).s);
          delete(trim,1,4);
          memo1.Lines.Add(trim);
        end
        else if syntax=3  then {SYN_CI_STRING}
        begin
 	      	Memo1.Lines.Add(strpas(@CI_String_T(attrVal)));
        end
        else if syntax=20 then {SYN_CLASS_NAME}
        begin
          memo1.Lines.Add(strpas(@Class_Name_T(attrVal)));
        end
        else if syntax=22 then {SYN_COUNTER}
        begin
          memo1.Lines.Add(inttostr(Counter_T(attrVal)));
        end
        else if syntax=1  then {SYN_DIST_NAME}
        begin
          memo1.Lines.Add(strpas(@DN_T(attrVal)))
        end
        else if syntax=14 then {SYN_EMAIL_ADDRESS}
        begin
          trim:=strpas(@EMail_Address_T(attrptr^).address);
          delete(trim,1,4);
          memo1.Lines.Add(trim);
        end
        else if syntax=11 then {SYN_FAX_NUMBER}
        begin
          memo1.Lines.Add(strpas(@Fax_Number_T(attrVal^).telephoneNumber));
        end
        else if syntax=26 then {SYN_HOLD}
        begin
          memo1.Lines.Add(strpas(@Hold_T(attrVal^).objectName));
          memo1.Lines.Add(inttostr(Hold_T(attrVal^).amount));
        end
        else if (syntax=8) or (syntax=27) then {SYN_INTEGER}
        begin
          memo1.Lines.Add(inttostr(Integer_T(attrVal)));
        end
        else if syntax=12 then {SYN_NET_ADDRESS}
        begin
          memo1.Lines.Add('Address Type: '+inttostr(Net_Address_T(attrptr^).addressType));
          memo1.Lines.Add('Address Length: '+inttostr(Net_Address_T(attrptr^).addressLength));
{          memo1.Lines.Add('Address: '+(strpas(@Net_Address_T(attrptr^).address[0])));}
        end
        else if syntax=5  then {SYN_NU_STRING}
        begin
          memo1.Lines.Add(strpas(@NU_String_T(attrVal)));
        end
        else if syntax=17 then {SYN_OBJECT_ACL}
        begin
          privs:=Object_ACL_T(attrptr^).privileges;
          {showMessage(inttostr(privs));}
          sattrName:=strpas(@Object_ACL_T(attrVal^).protectedAttrName);
          rights:='[';
          if pos('[Entry Rights]',sattrName)<>0 then
          begin
             if(BOOLEAN(privs and DS_ENTRY_BROWSE)) then {privs & 0x01) /* DS_ENTRY_BROWSE */}
                rights:=rights+'B';
             if(BOOLEAN(privs and DS_ENTRY_ADD)) then { privs & 0x02)	/* DS_ENTRY_ADD */}
                rights:=rights+'A';
             if(BOOLEAN(privs and DS_ENTRY_DELETE)) then {privs & 0x04) /* DS_ENTRY_DELETE */}
                rights:=rights+'D';
             if(BOOLEAN(privs and DS_ENTRY_RENAME)) then {privs & 0x08) /* DS_ENTRY_RENAME */}
                rights:=rights+'R';
             if(BOOLEAN(privs and DS_ENTRY_SUPERVISOR)) then {privs & 0x10) /* DS_ENTRY_SUPERVISOR */}
                rights:=rights+'S';
          end
          else
          begin
             if pos('[SMS Rights]',sattrNAme)<>0 then
             begin
                if(BOOLEAN(privs and 1)) then  {DS_SMS_SCAN}
                   rights:=rights+'S';
                if(BOOLEAN(privs and 2)) then {DS_SMS_BACKUP}
                   rights:=rights+'B';
                if(BOOLEAN(privs and 3)) then  {DS_SMS_RESTORE}
                   rights:=rights+'R';
                if(BOOLEAN(privs and 4)) then {DS_SMS_RENAME}
                   rights:=rights+'C';
                if(BOOLEAN(privs and 5)) then {DS_SMS_DELETE}
                   rights:=rights+'D';
                if(BOOLEAN(privs and 6)) then {DS_SMS_ADMIN}
                   rights:=rights+'A';
             end
             else 	{/* Attribute Rights which applies to all others */}
             begin
                if(BOOLEAN(privs and DS_ATTR_COMPARE)) then
                   rights:=rights+'C';
                if(BOOLEAN(privs and DS_ATTR_READ)) then
                   rights:=rights+'R';
                if(BOOLEAN(privs and DS_ATTR_WRITE)) then
                   rights:=rights+'W';
                if(BOOLEAN(privs and DS_ATTR_SELF)) then
                   rights:=rights+'A';
                if(BOOLEAN(privs and DS_ATTR_SUPERVISOR)) then
                   rights:=rights+'S';
             end;
          end;
          memo1.Lines.Add(strpas(@Object_ACL_T(attrVal^).protectedAttrName)+' '+rights+']');
        {The subjectName is a copy of protectedAttrName?? in Delphi}
        {  memo1.Lines.Add('Subject: '+strpas(@Object_ACL_T(attrval^).subjectName));}

        end
        else if syntax=13 then {SYN_OCTET_LIST}
        begin
        	memo1.Lines.Add('Because the syntax SYN_OCTET_LIST is a linked list');
           memo1.Lines.Add('it is not shown here');
        end
        else if syntax=9  then {SYN_OCTET_STRING}
        begin
          memo1.Lines.Add('Length: 0x'+inttohex(Octet_String_T(attrptr^).length,1));
          memo1.lines.Add('Data: 0x'+inttohex(uint8(@Octet_String_T(attrptr^).data),1));
        end
        else if syntax=15 then {SYN_PATH}
        begin
          memo1.Lines.Add('Name Space Type: '+inttostr(Path_T(attrptr^).nameSpaceType));
         {The path element is a duplicate of volumeName??}
         { trim:=strpas(@Path_T(attrptr^).path);
          delete(trim,1,4);
          memo1.Lines.Add('Path: '+trim);}
          trim:=strpas(@Path_T(attrptr^).volumeName);
          delete(trim,1,8);
          memo1.Lines.Add('Volume Name: '+trim);
        end
        else if syntax=18 then {SYN_PO_ADDRSS}
        begin
          memo1.Lines.Add(strpas(@Postal_Address_T(attrVal^)));
        end
        else if syntax=4  then {SYN_PR_STRING}
        begin
          memo1.Lines.Add(strpas(@PR_String_T(attrVal)));
        end
        else if syntax=16 then {SYN_REPLICA_POINTER}
        begin
          memo1.Lines.Add('Server Name: '+strpas(@Replica_Pointer_T(attrVal^).serverName));
          memo1.Lines.Add('Replica Type: '+inttostr(Replica_Pointer_T(attrVal^).replicaType));
          memo1.Lines.Add('Replica Number: '+inttostr(Replica_Pointer_T(attrVal^).replicaNumber));
          memo1.Lines.Add('Count: '+inttostr(Replica_Pointer_T(attrVal^).count));
{          memo1.Lines.Add('Replica Address Hint: '+inttostr(replicapointert.replicaAddressHint));}        end
        else if syntax=21 then {SYN_STREAM}
        begin
          ccode := NWDSOpenStream(dContext, @gobjectName, @attrname, NWDS_FLAGS(1), FileHandle);

          if(ccode=0) then
          begin
             _lread(FileHandle, tmpBuffer, DEFAULT_MESSAGE_LEN);
             FileHandle2:=_lcreat('c:\temp.txt',0);
             _lwrite(FileHandle2, tmpBuffer, DEFAULT_MESSAGE_LEN);
             _lclose(FileHandle);
             _lclose(Filehandle2);
             if fileexists('c:\temp.txt') then
               memo1.Lines.LoadFromFile('c:\temp.txt')
             else
               memo1.Lines.Add('Stream not available');
          end
          else
          begin
             ShowMessage('NWDSOpenStream returned: '+inttostr(ccode));
          end;
        end
        else if syntax=10 then {SYN_TEL_NUMBER}
        begin
          memo1.Lines.Add(strpas(@TN_String_T(attrVal)));
        end
        else if (syntax=24) then {SYN_TIME}
        begin
          seconds:=Integer_T(attrVal);
          days:=(719163.00-0.16666)+(seconds/86400); {There are 86400 sec in a day}
          memo1.Lines.Add(FormatDateTime('dddd mmmm, d, yyyy tt',days));
        end
        else if syntax=19 then {SYN_TIMESTAMP}
        begin
          seconds:=NWDS_TimeStamp_T(attrVal^).wholeSeconds;
          days:=(719163.00-0.16666)+(seconds/86400); {There are 86400 sec in a day}
          memo1.Lines.Add(FormatDateTime('dddd mmmm, d, yyyy tt',days));
          memo1.Lines.Add('Event Id: '+inttostr(NWDS_TimeStamp_T(attrVal^).eventID));
        end
        else if syntax=25 then {SYN_TYPED_NAME}
        begin
          memo1.Lines.Add('Object Name: '+strpas(@Typed_Name_T(attrVal^).objectName));
          memo1.Lines.Add('Level: '+inttostr(Typed_Name_T(attrVal^).level));
          memo1.Lines.Add('Interval: '+inttostr(Typed_Name_T(attrVal^).interval));
        end
        else {SYN_UNKNOWN}
        begin
          ShowMessage('Syntax is Unknown'+inttostr(syntax));
          j:=valcount;
          exit;
        end;
        if (ccode <> 0)then
			begin
           ShowMessage('NWDSGetAttrVal Failed'+#13+'Error Code: '+inttostr(ccode));
           Screen.Cursor := crDefault;
           exit;
		   end;
  	LocalUnlock(hattrValue);
		LocalFree(hattrValue);
     end;
  	NWDSFreeBuf(inptr);
	   NWDSFreeBuf(outptr);
     if memo1.Lines.Count>21 then
      Memo1.ScrollBars:=ssVertical;
  end;
end;

procedure TMainForm.ListBox1Click(Sender: TObject);
var
   TheItem, TheString:String;

begin
   TheItem:=listbox1.items[listbox1.Itemindex];
   ListBox2.items.Clear;
   Memo1.Lines.clear;

   if TheItem='..'then
   begin
     thestring:=Combobox2.Text;
     if pos('.',thestring)<>0 then
     	Delete(thestring,1,pos('.',thestring))
     else
        thestring:='[Root]';
     ComboBox2.Text:=thestring;
     BitBtn1Click(ListBox1);
     exit;
   end
   else
     strpcopy(@gobjectName,theitem+'.'+ComboBox2.Text);
   GetAttributes;
end;


procedure TMainForm.GetAttributes;
var
   ccode:NWDSCCODE;
   iterator:NWDS_ITERATION;
   outBuf3,inbuf3:^Buf_T;
   inptr, outptr:pointer;
   attrcount, valcount:NWCOUNT;
   i:Integer;
   syntax:NWSYNTAX_ID;
begin
  ccode:=NWDSAllocBuf(DEFAULT_MESSAGE_LEN, @inbuf3);
  if (ccode <> 0)then
  begin
        ShowMessage('NWDSAllocBuf Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        exit;
  end;

  inptr:=inBuf3;

  ccode:=NWDSInitBuf(dContext,DSV_READ,inptr);
  if (ccode <> 0)then
  begin
        ShowMessage('NWDSInitBuf Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        exit;
  end;

  ccode:=NWDSAllocBuf(DEFAULT_MESSAGE_LEN, @outBuf3);
  if (ccode <> 0)then
  begin
        ShowMessage('NWDSAllocBuf Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        exit;
  end;

	iterator:=-1;

  outptr:=outBuf3;
  ccode:=NWDSRead(dContext,@gobjectName,0,TRUE,inptr,@iterator,outptr);
  if (ccode <> 0) then
  begin
  		if (ccode = -603) then
        begin
        	ShowMessage('-603: The Requested attribute could not be found!');
        end
        else if (ccode = -601) then
        	ShowMessage('-601: The Requested object could not be read!')
        else
          ShowMessage('NWDSRead Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        exit;
  end;
  ccode:=NWDSGetAttrCount(dContext,outptr,@attrCount);
  if (ccode <> 0)then
  begin
        ShowMessage('NWDSGetAttrCount Failed'+#13+'Error Code: '+inttostr(ccode));
        Screen.Cursor := crDefault;
        exit;
  end;
  for i:=1 to attrcount do
  begin
     ccode:=NWDSGetAttrName(dContext,outptr,@attrName,@valCount,@syntax);
       if (ccode <> 0)then
       begin
         ShowMessage('NWDSGetAttrName Failed'+#13+'Error Code: '+inttostr(ccode));
         Screen.Cursor := crDefault;
         exit;
       end;
       ListBox2.Items.Add(strpas(attrName));
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
       NWDSFreeContext(dContext);
       NWFreeUnicodeTables;
end;

end.
